<?php
/*
* 2007-2011 PrestaShop 
*
* NOTICE OF LICENSE
*
* This source file is subject to the Open Software License (OSL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/osl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2011 PrestaShop SA
*  @version  Release: $Revision: 6594 $
*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');


class AdminSaleCategory extends AdminTab
{
	private $_nbProcessedCategories;
	private $_nbProcessedProducts;

	public function __construct()
	{
		$this->_nbProcessedCategories=0;
		$this->_nbProcessedProducts=0;	
	
		parent::__construct();
	}

	public function viewAccess($disable = false)
	{
		$result = parent::viewAccess($disable);
		return $result;
	}

	public function postProcess()
	{
		global $cookie, $currentIndex;
		
		if (Tools::isSubmit('submitSetReductionSale'))
		{
			$this->_processSetCategoryRecurse(Tools::getValue('categories'),Tools::getValue('recurse')=="on"?true:false);
				
			if (!sizeof($this->_errors))
			{
				Tools::redirectAdmin($currentIndex.'&_conf=1&nbProcessedCategories='.$this->_nbProcessedCategories.'&nbProcessedProducts='.$this->_nbProcessedProducts.'&token='.($token ? $token : Tools::getValue('token')));
			}				
		}
		elseif (Tools::isSubmit('submitUnsetReductionSale'))
		{
			$this->_processUnsetCategoryRecurse(Tools::getValue('categories'),Tools::getValue('recurse')=="on"?true:false);
			
			if (!sizeof($this->_errors))
			{
				Tools::redirectAdmin($currentIndex.'&_conf=1&nbProcessedCategories='.$this->_nbProcessedCategories.'&nbProcessedProducts='.$this->_nbProcessedProducts.'&token='.($token ? $token : Tools::getValue('token')));
			}			
		}
		$this->displayErrors();
	}

	public function displayErrors()
	{
		parent::displayErrors();
	}
	
	public function displayConf()
	{
		if (Tools::getValue('_conf'))
			echo '<div class="conf">
				<img src="../img/admin/ok2.png" />
				'.Tools::getValue('nbProcessedCategories').' '.$this->l('Categories and').' '.Tools::getValue('nbProcessedProducts').' '.$this->l('Products successfully updated.').'
			</div>';
	}	

	public function display()
	{
		global $cookie,$currentIndex;
		
		//$this->displayConf();

		echo '	<fieldset>
			<legend>'.$this->l('Set reduction/sale for products of category').'</legend>
			<form method="post" action="index.php?tab=AdminSaleCategory&token='.($token ? $token : Tools::getValue('token')).'&submitSetReductionSale">
				<label>'.$this->l('On category:').' </label>
				<select name="categories" id="categories">';
		$categories = Category::getCategories((int)($cookie->id_lang),false);
		Category::recurseCategory($categories, $categories[0][1], 1);					
				
		echo '	
				    </select>
				    <br />
				    <input type="checkbox" name="recurse">
				  <label style="font-size:12px;font-weight:normal">'.$this->l('Recurse subcategories').'</label>  
				    <br /><br /><br />
				    <fieldset style="font-size:13px">
				    <legend  >'.$this->l('Reduction').'</legend>
				    <label>'.$this->l('Set reduction for products').' </label> 
				    <input type="checkbox" name="on_reduction">		
				    <br />		
				    <br />		
				    <label class="clear">'.$this->l('From:').' </label>
				    <div class="margin-form">
					    <input type="text" size="20" id="date_from" name="date_from" value="" />
					    <p class="clear">'.$this->l('Start date/time from which reduction should be applied').'<br />'.$this->l('Format: YYYY-MM-DD HH:MM:SS').'</p>
				    </div>
				      <label>'.$this->l('To:').' </label>
				    <div class="margin-form">
					    <input type="text" size="20" id="date_to" name="date_to" value="" />
					    <p class="clear">'.$this->l('End date/time at which reduction is no longer valid').'<br />'.$this->l('Format: YYYY-MM-DD HH:MM:SS').'</p>
				    </div>
				    <label>'.$this->l('Reduction:').' </label>
				    <div class="margin-form">
					    <input type="text" name="sp_reduction" value="0.00" size="11" />
					    <select name="sp_reduction_type">
						    <option selected="selected">---</option>
						    <option value="amount">'.$this->l('Amount').'</option>
						    <option value="percentage">'.$this->l('Percentage').'</option>
					    </select>
					    '.$this->l('(if set to "amount", the tax is included)').'
				    </div>
				    </fieldset>				    
				    <br />	
				    <fieldset style="font-size:13px">
				    <legend>'.$this->l('Sale').'</legend>
				    <label>'.$this->l('Set products as "on sale"').' </label> 
				    <input type="checkbox" name="on_sale">
				    </fieldset>
				    <br />	
				    <input type="submit" id="submitSetReductionSale" class="button" value="'.$this->l('Apply').'"/>
			</form>	
			</fieldset>';	
			
			
			
			
		echo '	<br /><br />
			<fieldset>
			<legend>'.$this->l('Remove reduction/sale for products of category').'</legend>
			<form method="post" action="index.php?tab=AdminSaleCategory&token='.($token ? $token : Tools::getValue('token')).'&submitUnsetReductionSale">
				<label>'.$this->l('On category:').' </label>
				<select name="categories" id="categories">';
		Category::recurseCategory($categories, $categories[0][1], 1);
			
		echo '	
				    </select>
				    <br />
				    <input type="checkbox" name="recurse">
				    <label style="font-size:12px;font-weight:normal">'.$this->l('Recurse subcategories').'</label>  
				    <br /><br /><br />       
				    <fieldset style="font-size:13px">
				    <legend  >'.$this->l('Reduction').'</legend>
				    <label>'.$this->l('Remove reduction for products').' </label> 
				    <input type="checkbox" name="on_reduction">		
				    <br />		
				    </fieldset>				    
				    <br />	
				    <fieldset style="font-size:13px">
				    <legend>'.$this->l('Sale').'</legend>
				    <label>'.$this->l('Unset products as "on sale"').' </label> 
				    <input type="checkbox" name="on_sale">
				    </fieldset>
				    <br />	
				    <input type="submit" id="submitUnsetReductionSale" class="button" value="'.$this->l('Apply').'"/>
			</form>	
			</fieldset>';					
		
		includeDatepicker(array('date_from', 'date_to'), true);
// 		}
	} 
	
	private function _processSetCategoryRecurse($id_category, $recurse)
	{
		global $cookie, $currentIndex;
		
		$this->_nbProcessedCategories+=1;
		
		$reduction = (float)(Tools::getValue('sp_reduction'));
		$reduction_type = !$reduction ? 'amount' : Tools::getValue('sp_reduction_type');
		$from = Tools::getValue('date_from');
		$to = Tools::getValue('date_to');		
		
		$sql='SELECT cp.`id_product`
		      FROM `'._DB_PREFIX_.'category_product` cp
		      WHERE cp.`id_category`='.$id_category;
		$query_result = Db::getInstance()->ExecuteS($sql);			
	
		foreach($query_result as $row)
		{
			$this->_nbProcessedProducts+=1;
			
			$id_product = $row['id_product'];

			if(Tools::getValue('on_reduction')=="on")
			{
				$product = new Product($id_product);
                if($reduction_type == 'percentage')
                    $product->reduction_percent=$reduction;
                else
                    $product->reduction_price=$reduction;
                $product->reduction_from=!$from ? '0000-00-00 00:00:00' : $from;
                $product->reduction_to=!$to ? '0000-00-00 00:00:00' : $to;
                
				if(!$product->update())
					$this->_errors[] = Tools::displayError('An error occurred while updating the product.');
            
            
				// $id_shop = Tools::getValue('sp_id_shop');
				// $id_currency = Tools::getValue('sp_id_currency');
				// $id_country = Tools::getValue('sp_id_country');
				// $id_group = Tools::getValue('sp_id_group');
				// $price = Tools::getValue('sp_price');
				// $from_quantity = Tools::getValue('sp_from_quantity');
				
				// SpecificPrice::deleteByProductId($id_product);
				
				// $specificPrice = new SpecificPrice();
				// $specificPrice->id_product = $id_product;
				// $specificPrice->id_shop = (int)($id_shop);
				// $specificPrice->id_currency = (int)($id_currency);
				// $specificPrice->id_country = (int)($id_country);
				// $specificPrice->id_group = (int)($id_group);
				// $specificPrice->price = (float)($price);
				// $specificPrice->from_quantity = (int)($from_quantity);
				// $specificPrice->reduction = (float)($reduction_type == 'percentage' ? $reduction / 100 : $reduction);
				// $specificPrice->reduction_type = $reduction_type;
				// $specificPrice->from = !$from ? '0000-00-00 00:00:00' : $from;
				// $specificPrice->to = !$to ? '0000-00-00 00:00:00' : $to;
				// if (!$specificPrice->add())
					// $this->_errors[] = Tools::displayError('An error occurred while updating the specific price.');
			}
			
			if(Tools::getValue('on_sale')=="on")
			{
				$product = new Product($id_product);
				$product->on_sale = true;
				if(!$product->update())
					$this->_errors[] = Tools::displayError('An error occurred while updating the product.');
			}
		}
		
		if($recurse)
		{
			$sql='SELECT c.`id_category`
			      FROM `'._DB_PREFIX_.'category` c
			      WHERE c.`id_parent`='.$id_category.
                  ' AND c.`active`=1';
			$query_result = Db::getInstance()->ExecuteS($sql);			
		
			foreach($query_result as $row)
			{
			    $this->_processSetCategoryRecurse($row['id_category'], $recurse);
			}
		}
	}
    
    
	private function _processUnsetCategoryRecurse($id_category, $recurse)
	{
		global $cookie, $currentIndex;
		
		$this->_nbProcessedCategories+=1;
		
		$sql='SELECT cp.`id_product`
		      FROM `'._DB_PREFIX_.'category_product` cp
		      WHERE cp.`id_category`='.$id_category;
		$query_result = Db::getInstance()->ExecuteS($sql);			
		
		foreach($query_result as $row)
		{
			$this->_nbProcessedProducts+=1;
		
			$id_product = $row['id_product'];

			if(Tools::getValue('on_reduction')=="on")
            {
				$product = new Product($id_product);
                $product->reduction_percent=0;
                $product->reduction_price=0;
                $product->reduction_from='1900-01-01 00:00:00';
                $product->reduction_to='1900-01-01 00:00:00';
				if(!$product->update())
					$this->_errors[] = Tools::displayError('An error occurred while updating the product.');
                
            
				// if(!SpecificPrice::deleteByProductId($id_product))
					// $this->_errors[] = Tools::displayError('An error occurred while deleting the specific price.');
            }
			
			if(Tools::getValue('on_sale')=="on")
			{
				$product = new Product($id_product);
				$product->on_sale = false;
				if(!$product->update())
					$this->_errors[] = Tools::displayError('An error occurred while updating the product.');
			}
		}
		
		if($recurse)
		{
			$sql='SELECT c.`id_category`
			      FROM `'._DB_PREFIX_.'category` c
			      WHERE c.`id_parent`='.$id_category.
                  ' AND c.`active`=1';
			$query_result = Db::getInstance()->ExecuteS($sql);			
		
			foreach($query_result as $row)
			{
			    $this->_processUnsetCategoryRecurse($row['id_category'], $recurse);
			}
		}
	}    
    
}


